<!--商城首页免费tab created By 1173944134@qq.com-->
<template>
    <!--未预约弹窗-->
    <div class="yidialog-con sta-reserve-dia" id="staReserveDia">
        <div class="yid-back"></div>
        <div class="yid-con flex-row yid-con-col">
            <div class="yid-con-body flex-row">
                <div class="kj-djs"></div>
                <div class="time"></div>
                <div class="title"></div>
                <div class="btn-top"></div>
                <div class="flex-row btn">预约</div>
                <img src="" style="display: none;" class="live-badge"/>
                <!--<div class="btn-baom-con">
                    <img src="" class="btn-baom heart-beat"/>
                </div>-->
            </div>
            <div class="yid-cls-con">
                <img src="" class="yid-cls"/>
            </div>
        </div>
    </div>
    <!--toast-->
    <div class="yidialog-con yid-toast-con" id="toastCon">
        <div class="yid-back"></div>
        <div class="yid-con flex-row">
            <div class="yid-con-body flex-row">
                <!--消息-->
                <div class="msg"></div>
            </div>
        </div>
    </div>
    <!--弹窗-->
    <!--<div class="yidialog-con" id="Dia">
        <div class="yid-back"></div>
        <div class="yid-con flex-row yid-con-col">
            <div class="yid-con-body flex-row">
                <div class="kj-djs"></div>
                <img src="" style="display: none;" class="coupon-img"/>
                <div class="btn-baom-con">
                    <img src="" class="btn-baom heart-beat"/>
                </div>
            </div>
            <div class="yid-cls-con">
                <img src="" class="yid-cls"/>
            </div>
        </div>
    </div>-->
</template>

<script>
    export default {
        name: 'indexFree',
        data: {
            freeReserve: ApiHelper.SERVER + '/dengta/dailyFreeShow/{id}/reserve.json', // 每日放映厅预约
            freeNoReserve: ApiHelper.SERVER + '/dengta/dailyFreeShow/{id}/reserve-cancel.json', // 每日放映厅取消预约
            courseImg: resourcePath + '/imgs/groupPurchase/newCourseImg/',
            imgPath: resourcePath + '/imgs/groupPurchase/index/',
            pvuv: ApiHelper.SERVER + '/dengta/common/act/10029/addPvuv.json' // pvuv微信通用接口
        },
        // pvuvkey
        pvuvKey: {},
        // 接口数据
        actData: {
            notificationCallback: null, // 弹窗回调引用可执行
            curTime: '',
            living: false, // 是否在直播
            jumpUrl: '', // 直播地址
            yyDia: false, // 从链接进来的
            update: false,
            status: 0 // 0-不能参加，1-可以参加，2-已购买
        },
        // 曝光统计
        sendExposePvuv: function (data, callback) {
            data = data || {}
            !data.pvuvKeyId && (data.pvuvKeyId = 947)
            data.actChannels = data.channel || ApiHelper.getQueryString('channel')
            var channel = data.actChannels
            if (Object.prototype.toString.call(channel) === '[object Array]') {
                channel = channel[0]
            }
            var url = this.data.pvuv
            if (!data.actId) {
                url = url.replace('10029', 10033)
            }
            delete data.channel
            if (!data.expParam) {
                data.expParam = {
                    module: '',
                    tag: '',
                    channel: channel
                }
            }
            $.get(url, data)
            callback && setTimeout(callback, 300)
        },
        addPvuv: function (data, callback) {
            ApiHelper.myLog('pvuv>>>>', data)
            $.get(data.url || this.data.pvuv, data)
            callback && setTimeout(callback, 300)
        },
        // 初始化
        init: function () {
            var that = this
            // 全局弹窗引用
            window.indexFreeLiveDia = function (callback) {
                that.actData.notificationCallback && callback && callback()
            }
            ApiHelper.moreCourse && this.initMoreCourse()
        },
        // 调用原来弹窗
        notificationFn: function () {
            this.actData.notificationCallback = true
        },
        // 商城首页
        initMoreCourse: function () {
            var that = this

            function moduleFn(detail) {
                if (!detail) {
                    that.notificationFn()
                    return
                }
                var hasType7 = false
                $.each(detail.data, function (idx, one) {
                    one.moduleType === 7 && (hasType7 = true) && that.freeDailylive(one)
                })
                if (!hasType7) {
                    that.notificationFn()
                }
            }

            ApiHelper.$on('freeModuleData', function (e, detail) {
                moduleFn(detail)
            })
            ApiHelper.$on('freeModuleUpdate', function (e, detail) {
                that.actData.notificationCallback = null
                that.actData.update = true
                moduleFn(detail)
            })
        },
        // 免费页面每日放映 周末直播
        freeDailylive: function (data) {
            var that = this
            // data.curTime = 1584103200000 // 测试时间 1584185400000    1584189000000
            var dailyFreeShowModule = data.dailyFreeShowModule || []
            $.each(dailyFreeShowModule, function (idx, one) {
                if (idx > 0 && one.configShowType === 1) {
                    $('.dailyFreeLi[data-module=' + one.id + '] .videoState').css({
                        width: one.headTitle && one.headTitle.length >= 15 ? '3.4rem' : '3.05rem',
                    })
                    $('.dailyFreeLi[data-module=' + one.id + '] .videoGif').data('disabled', '1')
                    $('.dailyFreeLi[data-module=' + one.id + '] .daily-bottom').removeClass('daily-bottom').off('click')
                }
            })
            that.actData.curTime = data.curTime
            that.actData.yyDia = ApiHelper.getQueryString('yydia') === '1'
            var date = new Date(data.curTime)
            date.setHours(7)
            date.setMinutes(0)
            var startTime = date.getTime()
            date.setHours(20)
            var endTime = date.getTime()
            date.setHours(19)
            date.setMinutes(20)
            that.actData.living = that.actData.curTime > date.getTime() && that.actData.curTime < endTime
            var today = dailyFreeShowModule[0] // 默认取当天的
            that.actData.jumpUrl = today.jumpUrl
            // configShowType === 1 // 周六直播
            if (!today || today.configShowType !== 1) {
                that.notificationFn()
                return
            }
            // 卡片样式
            $('.dailyFreeLi[data-module=' + today.id + '] .videoState').css({
                color: '#ffffff',
                width: today.headTitle && today.headTitle.length >= 15 ? '3.4rem' : '3.05rem',
                backgroundImage: 'url("' + that.data.imgPath + 'videoStateLiveBg.png?v=' + window.jspVersionMoreChange + '")'
            })
            $('.dailyFreeLi .videoGif').css({
                borderRadius: '0.35rem'
            })
            $('.dailyFreeLi[data-module=' + today.id + '] .videoInfoBox ').css({
                boxShadow: 'none'
            })
            // 取消原有点击事件
            $('.dailyFreeLi[data-module=' + today.id + '] .videoGif').data('disabled', '1')
            $('.dailyFreeLi[data-module=' + today.id + '] .videoGif').off('click').click(function (e) {
                if (that.actData.living || data.curTime > endTime) {
                    that.goLiving()
                }
            })
            $('.dailyFreeLi[data-module=' + today.id + '] .daily-bottom').removeClass('daily-bottom').off('click').click(function (e) {
                if (that.actData.living || data.curTime > endTime) {
                    that.goLiving()
                }
            })

            var btnStyle = {
                width: '1.8rem',
                fontSize: '.28rem',
                color: '#fff',
                textAlign: 'center',
                padding: '.3rem 0',
                lineHeight: 0,
                borderRadius: '.3rem',
                backgroundColor: '#ffa200'
            }

            function updateBtn() {
                if (that.actData.curTime < startTime) {
                    return
                }
                var elCls = '.btnInfo[data-id=' + today.id + ']'
                $(elCls).text(that.actData.living ? '进入直播间' : '去看回放').removeClass('btnInfo').css(btnStyle).off('click').click(function (e) {
                    e.stopPropagation()
                    that.goLiving()
                })
            }

            // 直播中 或直播后
            if (that.actData.living || data.curTime > endTime) {
                var gifCls = '.videoGif[data-id=' + today.id + ']'
                var liveBadge = $('<img src="" class="badge"/>')
                $(gifCls).append(liveBadge)
                $(gifCls).find('.badge').css({
                    position: 'absolute',
                    width: '1.14rem',
                    height: '0.36rem',
                    top: '0.12rem',
                    left: '0.12rem'
                }).attr('src', that.data.imgPath + 'living-icon.png?v=' + window.jspVersionMoreChange)
                updateBtn()
                $('.dailyFreeLi[data-module=' + today.id + '] .lockBgImg').hide()
                $('.dailyFreeLi[data-module=' + today.id + '] .videoText').text(today.payedUserCount + '人已购买')
            }
            // 未到时间或过期不弹窗
            if (data.curTime < startTime || data.curTime > endTime) {
                that.notificationFn()
                return
            }
            // 链接有yydia=1 没预约
            if (today.showType === 4 && that.actData.yyDia) {
                !that.actData.update && that.showLiveReserveDia(today)
                return
            }
            // 未预约 或 未购买直播中
            if (today.showType === 4 || today.showType !== 2 && that.actData.living) {
                that.showStaDia(today)
            } else {
                that.notificationFn()
            }
            // showType  0: 显示（0点-19点非折扣期间）1: 显示 折扣期间 显示倒计时 2: 已经购买 3: 已预约 4: 没预约
        },
        // 周末未预约弹窗
        showStaDia: function (data) {
            var that = this
            var key = 'index_free_reserve'
            var today = new Date(that.actData.curTime)
            var dateKey = (today.getMonth() + 1) + '' + today.getDate()
            if (that.actData.living) {
                dateKey = 'living_' + dateKey
            }
            var indexFreeData = that.getStorageSync(key) || {}

            if (indexFreeData.reserve && indexFreeData.reserve[dateKey]) {
                that.notificationFn()
                return
            }
            indexFreeData.reserve = {}
            indexFreeData.reserve[dateKey] = 1
            that.setStorageSync(key, indexFreeData)
            that.showLiveReserveDia(data)
        },
        // 去直播页面
        goLiving: function () {
            location.href = this.actData.jumpUrl
        },
        // 预约弹窗
        showLiveReserveDia: function (data) {
            var that = this
            that.sendExposePvuv({
                pvuvKeyId: that.actData.yyDia ? 1325 : (that.actData.living ? 1319 : 1317)
            })
            // 弹窗
            $(staReserveDia).appendTo($('body'))
            if (that.actData.living) {
                $('#staReserveDia .btn').text('进入直播间')
                $('#staReserveDia .live-badge').attr('src', that.data.imgPath + 'living-badge.png?v=' + window.jspVersionMoreChange)
                $('#staReserveDia .live-badge').show()
                $('#staReserveDia .btn-top').css({
                    opacity: 0
                })
            }
            $('#staReserveDia .title').text(data.showTitle)
            $('#staReserveDia .time').text(data.headTitle && data.headTitle.replace('直播', ''))
            $('#staReserveDia .btn-top').text(data.reserveUserCount + '人已预约')
            $('#staReserveDia .yid-con-body').css({
                backgroundImage: 'url("' + that.data.imgPath + 'free-live-back.png?v=' + window.jspVersionMoreChange + '")'
            })
            $('#staReserveDia .yid-cls').attr('src', that.data.imgPath + 'close-x.png?v=' + window.jspVersionMoreChange)
            $('#staReserveDia .yid-cls-con').click(function () {
                $('#staReserveDia').hide()
            })
            $('#staReserveDia .btn').click(function () {
                // 进入直播
                if (that.actData.living) {
                    that.sendExposePvuv({
                        pvuvKeyId: 1321
                    }, function () {
                        that.goLiving()
                    })
                    return
                }
                // 取消预约
                if ($(this).hasClass('btn-disabled')) {
                    $.post(that.data.freeNoReserve.replace('{id}', data.id), function (res) {
                        if (!res || (res.resultCode || {}).code !== 0) {
                            return
                        }
                        $('.alert_box').html('预约已取消').fadeIn(function () {
                            setTimeout(function () {
                                $('.alert_box').fadeOut()
                            }, 1000)
                        })
                        $('#staReserveDia .btn').removeClass('btn-disabled')
                    })
                    return
                }
                that.sendExposePvuv({
                    pvuvKeyId: that.actData.yyDia ? 1326 : 1320
                })
                window.indexFreeModule.exposeAndPvuvCountByPayedNum('dc_1114_daily_show_reserve_course_' + data.courseId + '_btn');
                $.post(that.data.freeReserve.replace('{id}', data.id), function (res) {
                    if (!res || (res.resultCode || {}).code !== 0) {
                        return
                    }
                    $('#staReserveDia .btn').addClass('btn-disabled')
                    $('.alert_box').html('预约成功，直播开始前，请留意通知哦').fadeIn(function () {
                        setTimeout(function () {
                            $('.alert_box').fadeOut();
                        }, 1000)
                    })
                })
            })
        },
        // toast消息
        showToast: function (msg, time, callback) {
            if ($('#toastCon').length === 0) {
                $(toastCon).appendTo($('body'))
            }
            $('#toastCon').css({
                display: 'flex'
            })
            $('#toastCon .msg').text(msg)
            setTimeout(function () {
                $('#toastCon').hide()
                callback && callback()
            }, time || 3000)
        },
        // 是否在可视区域 document.addEventListener('scroll', ApiHelper.throttle(function () {}, 500)
        isInView: function (selector) {
            if (!document.querySelector(selector)) {
                return false
            }
            var rect = document.querySelector(selector).getBoundingClientRect()
            var flag = false
            if (rect.top <= window.innerHeight && rect.top >= -rect.height) {
                flag = true
            }
            return flag
        },
        // 插入未来元素
        checkHas: function (selector, callback) {
            var that = this
            var addBannerCount = 0

            function check() {
                setTimeout(function () {
                    addBannerCount++
                    if ($(selector).length > 0) {
                        callback && callback.call(that)
                    } else {
                        addBannerCount < 5 && check()
                    }
                }, 1000)
            }

            check()
        },
        getStorageSync: function (key) {
            var storage = localStorage.getItem(key)
            try {
                storage = JSON.parse(storage)
            } catch (e) {
                storage = storage
            }
            return storage
        },
        setStorageSync: function (key, data) {
            localStorage.setItem(key, JSON.stringify(data))
        },
        //倒计时
        doubleEvelenTimeDown: function (cutDownTime) {
            var oneDay = 24 * 60 * 60 * 1000
            var that = this
            var courseTime = setInterval(function () {
                cutDownTime -= 10
                if (cutDownTime > oneDay) {
                    var hh = Math.floor(cutDownTime / 1000 / 60 / 60 % 24)
                    var dd = Math.floor(cutDownTime / 1000 / 60 / 60 / 24)
                    dd = dd > 99 ? 99 : dd
                    var mm = parseInt(cutDownTime / 1000 / 60 % 60)
                    var ss = parseInt(cutDownTime / 1000 % 60)
                    var ms = parseInt(cutDownTime / 100 % 10)
                    hh = (hh >= 0 && hh < 10) ? ("0" + hh) : hh   //时
                    mm = (mm >= 0 && mm < 10) ? ("0" + mm) : mm   //分
                    ss = (ss >= 0 && ss < 10) ? ("0" + ss) : ss   //秒
                    ms = (ms >= 0 && ms < 10) ? ("0" + ms) : ms   //秒
                    $('.countDownNum11').html('<span class="days">' + dd + '天' + '<span class="hours">' + hh + '</span><span class="time_sign">:</span><span class="hours">' + mm + '</span><span class="time_sign">:</span><span class="hours">' + ss + '</span><span class="time_sign">:</span><span class="hours">' + ms + '</span>')
                } else {
                    var hh = Math.floor(cutDownTime / 1000 / 60 / 60)
                    var mm = parseInt(cutDownTime / 1000 / 60 % 60)
                    var ss = parseInt(cutDownTime / 1000 % 60)
                    var ms = parseInt(cutDownTime / 100 % 10)
                    if (hh < 0 || mm < 0 || ss < 0 || ms < 0) {
                        hh = 0
                        mm = 0
                        ss = 0
                        ms = 0
                        clearInterval(courseTime)
                    }
                    hh = (hh >= 0 && hh < 10) ? ("0" + hh) : hh   //时
                    mm = (mm >= 0 && mm < 10) ? ("0" + mm) : mm   //分
                    ss = (ss >= 0 && ss < 10) ? ("0" + ss) : ss   //秒
                    ms = (ms >= 0 && ms < 10) ? ("0" + ms) : ms   //秒
                    $('.coupon_time_h').text(hh)
                    $('.coupon_time_m').text(mm)
                    $('.coupon_time_s').text(ss)
                    $('.coupon_time_ms').text(ms)
                }
                clearInterval(courseTime)
                that.doubleEvelenTimeDown(cutDownTime)
            }, 10)
        }
    }
</script>

<style scoped lang="less">
    .flex-row {
        display: -moz-box;
        /* 老版本语法: Firefox (buggy) */
        display: -ms-flexbox;
        /* 混合版本语法: IE 10 */
        display: -webkit-flex;
        /* 新版本语法: Chrome 21+ */
        display: flex;
    }

    @cl-mask: rgba(0, 0, 0, 0.85);
    /**弹窗**/
    .yidialog-con {
        position: fixed;
        width: 100%;
        height: 100%;
        top: 0px;
        left: 0px;
        display: flex;
        align-items: center;
        justify-content: center;
        z-index: 1000;

        .yid-back {
            position: absolute;
            left: 0px;
            top: 0px;
            width: 100%;
            height: 100%;
            text-align: center;
            background: @cl-mask;
        }

        .yid-con {
            position: relative;
            display: flex;
            justify-content: center;
            align-content: center;
            color: #ffffff;
            flex-wrap: wrap;

            .yid-cls {
                position: relative;
                z-index: 9999;
                width: 0.51rem;
                height: 0.51rem;
                flex-shrink: 0;
            }

            .yid-hand {
                position: absolute;
                width: 1rem;
                top: 3.1rem;
                right: 0.1rem;
                animation: handClick 1s infinite;
            }
        }

        .yid-con-col {
            flex-direction: column;
        }
    }

    /**toast**/
    .yid-toast-con {
        display: none;

        .yid-back {
            opacity: 0;
        }

        .yid-con {
            .yid-con-body {
                justify-content: center;
                align-items: center;

                .msg {
                    padding: 20px;
                    background-color: #333333;
                    color: #ffffff;
                    font-size: 28px;
                    border-radius: 10px;
                }
            }
        }
    }

    /**首页免费周六直播弹窗**/
    .sta-reserve-dia {
        .yid-con-body {
            background-repeat: no-repeat;
            background-position: center top;
            background-size: 100% auto;
            width: 620px;
            height: 681px;
            flex-direction: column;
            align-items: center;
            position: relative;

            .time {
                color: #ff3b3b;
                margin-top: 369px;
                font-size: 28px;
            }

            .title {
                color: #0f0f0f;
                font-size: 40px;
                font-weight: bold;
                margin-top: 6px;
            }

            .btn-top {
                color: #9c9c9c;
                font-size: 22px;
                margin-top: 107px;
            }

            .btn {
                width: 240px;
                height: 60px;
                background-color: #ffb619;
                border-radius: 30px;
                line-height: normal;
                align-items: center;
                justify-content: center;
                font-size: 28px;
                color: #ffffff;
                margin-top: 9px;
            }

            .btn-disabled {
                background-color: #cccccc;
            }

            .live-badge {
                width: 154px;
                height: 37px;
                top: 455px;
                left: 233px;
                position: absolute;
            }
        }

        .yid-cls-con {
            align-self: center;
            margin-top: 74px;
        }
    }

    .my-hand-ani {
        animation: myHandAni 1s infinite;
    }

    @keyframes myHandAni {
        50% {
            left: 80px;
        }
        0%, 100% {
            left: 50px;
        }
    }

    @keyframes iconClick {
        0%, 100% {
            margin-bottotm: 0;
        }
        50% {
            margin-bottom: -35px;
            transform: scale(1.1);
        }
    }

    @keyframes handClick {
        from {
            margin-top: 0rem;
            margin-right: 0rem;
        }
        50% {
            margin-top: -0.1rem;
            margin-right: 0.1rem;
            transform: scale(0.9);
        }
        to {
            margin-top: -0rem;
            margin-right: 0rem;
        }
    }

    .scale-size {
        animation: scaleSize 2s infinite;
    }

    @keyframes scaleSize {
        from {
            transform: scale(0.9);
            opacity: 0.9;
        }
        50% {
            transform: scale(1.2);
            opacity: 1;
        }
        to {
            transform: scale(0.9);
            opacity: 0.9;
        }
    }

    .heart-beat {
        animation: heartBeat 1s infinite;
    }

    @keyframes heartBeat {
        0% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }

        14% {
            -webkit-transform: scale(.8);
            transform: scale(.8);
        }

        28% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }

        42% {
            -webkit-transform: scale(.8);
            transform: scale(.8);
        }

        70% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }
    }

    /**淡入*/
    .fade-in {
        animation: fadeIn 1s;
    }

    @keyframes fadeIn {
        from {
            opacity: 0;
        }
        to {
            opacity: 1;
        }
    }
</style>
